import java.util.*;

/**
 * Examen Septiembre 2011-A - Banco que envía diferentes tipos mensajes a sus clientes según diferentes tipos de productos contratados.
 * @author Antonio Herrera Pérez
 * @version Junio 2012
 */
public class Banco
{
    private static Consola consola = Consola.getConsola();

    private ArrayList<Cliente> listaClientes = new ArrayList<Cliente>();
    private Cliente cliente;
    private int numCliente;

    private ArrayList<Producto> listaProductos = new ArrayList<Producto>();
    private Producto producto;
    private int numProducto;
    
    Tarjeta_de_credito tarjeta_de_credito;
    Tarjeta_de_debito tarjeta_de_debito;
    Plan_de_pensiones plan_de_pensiones;
    Seguro seguro;
    Fondo_de_inversion fondo_de_inversion;
    

    private Banco()
    {
        /**
         * Se omite el tratamiento de altas/bajas de clientes/productos/mensajes y se generan automáticamente
         * Se omiten métodos de modificación y acceso
         */
        crearClientes();
        crearProductos();

        contratarProductos();

        consola.imprimir("Enviando mensajes de ...");
        imprimirProductosCliente();

        consola.imprimir("Se enviaron los siguientes mensajes:");
        imprimirMensajesCliente();
    }

    public void crearClientes()
    {
        cliente = new Cliente("Cliente Uno");
        listaClientes.add(cliente);
        cliente = new Cliente("Cliente Dos");
        listaClientes.add(cliente);
        cliente = new Cliente("Cliente Tres");
        listaClientes.add(cliente);
    }    

    public int elegir()
    {
        return consola.leerEntero();
    }

    public void crearProductos()
    {       
        producto=new Tarjeta_de_credito();
        listaProductos.add(producto);
        producto=new Tarjeta_de_debito();
        listaProductos.add(producto);
        producto=new Plan_de_pensiones();
        listaProductos.add(producto);    
        producto=new Seguro();
        listaProductos.add(producto);
        producto=new Fondo_de_inversion();
        listaProductos.add(producto);         
    }    

    public void imprimirLista(List lista)
    {
        consola.imprimirLista(lista);
    }

    public void contratarProductos()
    {
        int numCliente=-1;
        while (numCliente!=0 || numProducto!=0)
        {
            consola.imprimir("Elija un cliente y producto por su número: [0][0] Salir");
            consola.imprimir("***********    CLIENTES    **********");
            imprimirLista(listaClientes);
            numCliente=elegir();

            consola.imprimir("***********    PRODUCTOS    **********");
            imprimirLista(listaProductos);
            numProducto=elegir();

            if ((numCliente!=0 && numProducto!=0)){
                listaClientes.get(numCliente-1).contratarProducto(listaProductos.get(numProducto-1));
                listaClientes.get(numCliente-1).recibirMensaje(listaProductos.get(numProducto-1).getCarta());
                listaClientes.get(numCliente-1).recibirMensaje(listaProductos.get(numProducto-1).getEmail());
                listaClientes.get(numCliente-1).recibirMensaje(listaProductos.get(numProducto-1).getSms());
            }
        }
    }

    public void imprimirProductosCliente()
    {
        for (Cliente cliente:listaClientes)
        {
            cliente.imprimirProductos();
        }
    } 

    public void imprimirMensajesCliente()
    {
        for (Cliente cliente:listaClientes)
        {
            cliente.imprimirMensajes();
        }
    }    
    
    public static void main(String[] args)
    {
        new Banco();
    }
}
